--Main LUA file global shortcuts and variables
lg = love.graphics
la = love.audio
lk = love.keyboard

--Game Elements and BaseFiles
require "AnAL.lua" -- Animations And Love --- by bartbes.
require "player.lua" -- playerBase Class. 
require "rock.lua" -- base for rock class
require "mouseHelper.lua"



-- game and world elements
world = {}
rocks = {}  -- the future of this table will be to use a function to create an object in the indexes. rocks[i] = newRock(<params>)

--BG = lg.newImage("game_bg.jpg") -- old BG. 
-- BG ELEMENTS> For later use we will do more. There is alot to add to the BG. 
sky = lg.newImage("bgSky.png")
walls = lg.newImage("bgCanyon.png")
ground = lg.newImage("bgFloor.png")

groundLevel = 475
grav = 10
score = 0


smax = 75

function love.load()

-- the game will start in this load function. The objects will run the show from then on. 
table.insert(world,rock) -- eventually will be part of a createRocks(num) function
table.insert(world,xan) -- make an instance of xan table in the world. 
table.insert(world,mouseHelper)


gtxt = love.graphics.newFont("ka1.ttf",15)
gtxtB = love.graphics.newFont("ka1.ttf",40)


--Feature Dickingsz
--[[
bgm = love.audio.newSource("sounds/beginLoop.ogg","stream") -- this is for large audio files. 
la.play(bgm)
bgm:setLooping(true)
bgm:setVolume(0.4)
--]]

slide = la.newSource("sounds/rockPush.mp3", "static") -- static would be good for this because it's small. We can keep it in RAM> 


end


function love.update(dt)
	
	for n, b in pairs(world) do -- index and Value : function
		b:update(dt)
	end

end



function love.draw()
 
	

	--lets get some temporary score UI and the counter function,

	love.graphics.setColor(255,255,255,255)
	love.graphics.setFont(gtxt)
	lg.draw(sky,0,0) -- should move to another place.. right now this is simple enough
	lg.draw(walls,0,0) -- should move to another place.. right now this is simple enough
	lg.draw(ground,0,0) -- should move to another place.. right now this is simple enough
	lg.print( "jumpSpeed : "..xan.jspd.."\n xan_y: "..xan.pos.y.."\n p_state: "..xan.state,x + 15, y+20)

	
	for n, b in pairs(world) do -- index(n)  and Value (b)
		b:draw() -- we tell the xan instance to draw.. so this goes to xan:draw()
	end
	
	--DBG
	love.graphics.setFont(gtxtB)
	love.graphics.setColor(150,15,10,255)
	lg.print("SCORE - "..score, 10, 50)

end

function addPoints(val)
	

	score = score + val

	
	
	--[[Move The fancy Counter Elsewhere
	local newScore = score + val
	--  want to get the value of the rock.(500)  
	-- increment score by one until it's added up.
	for i = score, newScore,1 do
		score = score +1 
	end
	--]] 
		


	
end

-- love system functions have been relpaced with love.event
-- we use this to quit the game with the press of a button 
function love.keypressed( key )
   if key == "escape" then
      love.event.push("q")
   end
   
   if key == "space" then 
		table.insert(world,rock)
   end
end

function checkHit ( a, b ) -- box collision
	
	if a.pos.x + a.drawVars.xo < b.pos.x - b.drawVars.xo or -- rightA border is LEFT of leftB border
	a.pos.x - a.drawVars.xo > b.pos.x + b.drawVars.xo or -- a is right of B
	a.pos.y < b.pos.y - b.drawVars.yo or -- a above topB
	a.pos.y - a.drawVars.yo > b.pos.y -- below bottomB.. Beccause the image origin is offset. 
	then return false -- because somehow we're outside of b's boundary. 
	else
	return true -- so if we get to here than we A and B are Overlappin. 
	end
	

end




--[[
	


--]]

