-- mouseHelper Base

-- load required mouseState images

noMouse = lg.newImage ("noClick.png")
bothMouse = lg.newImage ("bothClick.png")
rightMouse = lg.newImage ("rightClick.png")
leftMouse = lg.newImage ("leftClick.png")

--love command to hide mouse 
love.mouse.setVisible(false)
love.mouse.setGrab(true)


mouseHelper = {
				state = "no",
				img = noMouse,

			  }
			  
function mouseHelper:update(dt)
	 x = love.mouse.getX()
	 y = love.mouse.getY()
	 
	
	if love.mouse.isDown('l') and love.mouse.isDown('r') then
		mouseHelper.state = "both"
		mouseHelper.img = bothMouse
	elseif love.mouse.isDown('l') then
		mouseHelper.state = "left"
		mouseHelper.img = leftMouse
	elseif love.mouse.isDown('r') then
		mouseHelper.state = "right"
		mouseHelper.img = rightMouse
	else
		mouseHelper.state = "no"
		mouseHelper.img = noMouse
	end
	

end 

function mouseHelper:draw()

	lg.draw(mouseHelper.img, x, y, 0, 1,1, 32,32)

end 